## ![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/screenshots/beautyeye_logo_h.png) 
:cn: [点击进入简体中文版](https://github.com/JackJiang2011/beautyeye/blob/master/README.md)

:bulb: BeautyEye has migrated from [Google Code](https://code.google.com/p/beautyeye/) since 2015-01-30.

BeautyEye is a cross platform Java Swing look and feel;<br>
Benefit from basic GUI technology of Android, BeautyEye is so different from other look and feel.<br>
BeautyEye is open source and free.

## Source code online

Click here: [http://www.52im.net/thread-112-1-1.html](http://www.52im.net/thread-112-1-1.html)。

## Latest Release
#### :page_facing_up: v3.7 release note
 Release time: `2015-11-13 17：23`<br>
 1. Resolved text components can not edit on JPopupMenu; <br>
 2. Resolved issue that JFormattedTextField has not ui. <br>

> BeautyEye first code since 2012-05, v3.0 released date is 2012-09-11, latest version released date is 2015-11-13. [More release notes](https://github.com/JackJiang2011/beautyeye/wiki/BeautyEye-release-notes)

## Compatibility
BeautyEye can be run at java 1.5,1.6,1.7 and 1.8 or later.

[See compatibility test](https://github.com/JackJiang2011/beautyeye/wiki/Compatibility_test_results).

## Feature
* Cross-platform;
* Main ui style;
* Better compatibility.

## Demos
<b>Tip:</b> Ensure has install JRE(java1.5+).

* :paperclip: [Download demo jar\(Swingsets2\)](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/demo/excute_jar/SwingSets2\(BeautyEyeLNFDemo\).jar)
* :paperclip: [Download demo jar\(Swingsets3\)](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/demo2/SwingSets3(BeautyEyeLNFDemo).jar) <font color="#FF6600"> \[Recommend:thumbsup:\]</font>

## Download
:paperclip: .zip package：[Download now!](https://github.com/JackJiang2011/beautyeye/archive/v3.6.zip) (included demos, api docs , dist jar and so on).

## Development Guide
#### :triangular_flag_on_post: First step: Import *`beautyeye_lnf.jar`*
you can found dist jar *`beautyeye_lnf.jar`* at *“`/dist/`”*。

#### :triangular_flag_on_post: Second step: Code like this:
```Java
public static void main(String[] args)
{
    try
    {
        org.jb2011.lnf.beautyeye.BeautyEyeLNFHelper.launchBeautyEyeLNF();
    }
    catch(Exception e)
    {
        //TODO exception
    }
    ..................... Your code .........................
    ..................... Your code .........................
}
```

:green_book: Introduction：[BeautyEye L&F brief introduction](https://github.com/JackJiang2011/beautyeye/wiki/BeautyEye-L&F%E7%AE%80%E6%98%8E%E5%BC%80%E5%8F%91%E8%80%85%E6%8C%87%E5%8D%97).

## License
Open source and free.

## Contact
* Issues mail to :love_letter:  `jb2011@163.com`; </li>
* Welcome to Java Swing QQ:`259448663`  <a target="_blank" href="http://shang.qq.com/wpa/qunwpa?idkey=9971fb1d1845edc87bdec92ad03f329c1d1f280b1cfe73b6d03c13b0f7f8aba1"><img border="0" src="http://pub.idqqimg.com/wpa/images/group.png" alt="Java Swing技术交流" title="Java Swing技术交流"></a>;
* [Twitter](https://twitter.com/JackJiang2011/).

## About Author
![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/screenshots/js2.png)

## Preview
#### :triangular_flag_on_post: Part 1/2：[Original image](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/preview/be_lnf_preview_36.png)
![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/preview/be_lnf_preview_36.png)

#### :triangular_flag_on_post: Part 2/2：[Original image](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/preview/be_lnf_preview2_36.png)
![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/preview/be_lnf_preview2_36.png)

## More Screenshots
#### :triangular_flag_on_post: Case :one:：SwingSets2
:point_right: [See more](https://github.com/JackJiang2011/beautyeye/wiki/Screenshots-all-in-one)

#### :triangular_flag_on_post: Case :two:：SwingSets3
![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/screenshots/swingsets3/swingsets3_beautyeye.png)
:paperclip: [download jar\(Swingsets3\)](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/demo2/SwingSets3(BeautyEyeLNFDemo).jar)

#### :triangular_flag_on_post: Case :three:：DriodUIBuilder
![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/screenshots/drioduiduilder/drioduiduilder_beautyeye.png)

:point_right: DroidUIBuilder: [see more](https://github.com/JackJiang2011/DroidUIBuilder)

#### :triangular_flag_on_post: Sace :four:：Draw9patch
![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/screenshots/draw9patch/draw9patch1_beautyeye.png)
![](https://raw.githubusercontent.com/JackJiang2011/beautyeye/master/screenshots/draw9patch/draw9patch2_beautyeye.png)

## Wiki
:notebook_with_decorative_cover: [See more](https://github.com/JackJiang2011/beautyeye/wiki)

## Other projects
* **DroidUIBuilder**：一款开源Android GUI设计工具（已于2012年底停止开发），[:octocat: see more](https://github.com/JackJiang2011/DroidUIBuilder)。<br>
* **Swing9patch**：一组很酷的Java Swing可重用组件或UI效果，[:octocat: see more](https://github.com/JackJiang2011/Swing9patch)。<br>
